'use strict';

var internal = require('svelte/internal');

/* src\fa.svelte generated by Svelte v3.4.4 */

// (91:0) {#if i[4]}
function create_if_block(ctx) {
	var svg, g1, g0, path, path_d_value, svg_viewBox_value;

	return {
		c() {
			svg = internal.svg_element("svg");
			g1 = internal.svg_element("g");
			g0 = internal.svg_element("g");
			path = internal.svg_element("path");
			internal.attr(path, "d", path_d_value = ctx.i[4]);
			internal.attr(path, "fill", "currentColor");
			internal.attr(path, "transform", "translate(-256 -256)");
			internal.attr(g0, "transform", ctx.transform);
			internal.attr(g1, "transform", "translate(256 256)");
			internal.attr(svg, "viewBox", svg_viewBox_value = `0 0 ${ctx.i[0]} ${ctx.i[1]}`);
			internal.attr(svg, "style", ctx.style);
			internal.attr(svg, "aria-hidden", "true");
			internal.attr(svg, "role", "img");
			internal.attr(svg, "xmlns", "http://www.w3.org/2000/svg");
		},

		m(target, anchor) {
			internal.insert(target, svg, anchor);
			internal.append(svg, g1);
			internal.append(g1, g0);
			internal.append(g0, path);
		},

		p(changed, ctx) {
			if ((changed.i) && path_d_value !== (path_d_value = ctx.i[4])) {
				internal.attr(path, "d", path_d_value);
			}

			if (changed.transform) {
				internal.attr(g0, "transform", ctx.transform);
			}

			if ((changed.i) && svg_viewBox_value !== (svg_viewBox_value = `0 0 ${ctx.i[0]} ${ctx.i[1]}`)) {
				internal.attr(svg, "viewBox", svg_viewBox_value);
			}

			if (changed.style) {
				internal.attr(svg, "style", ctx.style);
			}
		},

		d(detaching) {
			if (detaching) {
				internal.detach(svg);
			}
		}
	};
}

function create_fragment(ctx) {
	var if_block_anchor;

	var if_block = (ctx.i[4]) && create_if_block(ctx);

	return {
		c() {
			if (if_block) if_block.c();
			if_block_anchor = internal.empty();
		},

		m(target, anchor) {
			if (if_block) if_block.m(target, anchor);
			internal.insert(target, if_block_anchor, anchor);
		},

		p(changed, ctx) {
			if (ctx.i[4]) {
				if (if_block) {
					if_block.p(changed, ctx);
				} else {
					if_block = create_if_block(ctx);
					if_block.c();
					if_block.m(if_block_anchor.parentNode, if_block_anchor);
				}
			} else if (if_block) {
				if_block.d(1);
				if_block = null;
			}
		},

		i: internal.noop,
		o: internal.noop,

		d(detaching) {
			if (if_block) if_block.d(detaching);

			if (detaching) {
				internal.detach(if_block_anchor);
			}
		}
	};
}

function instance($$self, $$props, $$invalidate) {
	let { icon, fw, flip, pull, rotate, size } = $$props;

let i;
let style;
let transform;

	$$self.$set = $$props => {
		if ('icon' in $$props) $$invalidate('icon', icon = $$props.icon);
		if ('fw' in $$props) $$invalidate('fw', fw = $$props.fw);
		if ('flip' in $$props) $$invalidate('flip', flip = $$props.flip);
		if ('pull' in $$props) $$invalidate('pull', pull = $$props.pull);
		if ('rotate' in $$props) $$invalidate('rotate', rotate = $$props.rotate);
		if ('size' in $$props) $$invalidate('size', size = $$props.size);
	};

	$$self.$$.update = ($$dirty = { icon: 1, fw: 1, pull: 1, size: 1, flip: 1, rotate: 1 }) => {
		if ($$dirty.icon) { $$invalidate('i', i = (icon && icon.icon) || [0, 0, '', [], '']); }
		if ($$dirty.fw || $$dirty.pull || $$dirty.size) { {
      let float;
      let width;
      const height = '1em';
      let lineHeight;
      let fontSize;
      let textAlign;
      let verticalAlign = '-.125em';
      const overflow = 'visible';
    
      if (fw) {
        textAlign = 'center';
        width = '1.25em';
      }
    
      if (pull) {
        float = pull;
      }
    
      if (size) {
        if (size == 'lg') {
          fontSize = '1.33333em';
          lineHeight = '.75em';
          verticalAlign = '-.225em';
        } else if (size == 'xs') {
          fontSize = '.75em';
        } else if (size == 'sm') {
          fontSize = '.875em';
        } else {
          fontSize = size.replace('x', 'em');
        }
      }
    
      const styleObj = {
        float,
        width,
        height,
        'line-height': lineHeight,
        'font-size': fontSize,
        'text-align': textAlign,
        'vertical-align': verticalAlign,
        overflow,
      };
      let styleStr = '';
      for (const s in styleObj) {
        if (styleObj[s]) {
          styleStr += `${s}:${styleObj[s]};`;
        }
      }
      $$invalidate('style', style = styleStr);
    } }
		if ($$dirty.flip || $$dirty.rotate) { {
      let t = '';
    
      if (flip) {
        let flipX = 1;
        let flipY = 1;
        if (flip == 'horizontal') {
          flipX = -1;
        } else if (flip == 'vertical') {
          flipY = -1;
        } else {
          flipX = flipY = -1;
        }
        t += ` scale(${flipX} ${flipY})`;
      }
    
      if (rotate) {
        t += ` rotate(${rotate} 0 0)`;
      }
    
      $$invalidate('transform', transform = t);
    } }
	};

	return {
		icon,
		fw,
		flip,
		pull,
		rotate,
		size,
		i,
		style,
		transform
	};
}

class Fa extends internal.SvelteComponent {
	constructor(options) {
		super();
		internal.init(this, options, instance, create_fragment, internal.safe_not_equal, ["icon", "fw", "flip", "pull", "rotate", "size"]);
	}
}

module.exports = Fa;
